<?php
namespace Teknisa\EST\Modules\Relatorios\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\FilterCriteria;

class Est33401RequisicaoDeEstoque extends \Zeedhi\Framework\Controller\Report{
    protected $reportService;
    protected $dataSourceManager;
    protected $nrorg;
    protected $birtStrategy;
    protected $reportMapping = array (
        'EST33401' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        "CDFILIAL" => "P_CDFILIAL",
                        "CDALMOXDEST" => "P_ALMOXARIFE", 
                        "CDALMOXDEST" => "P_TALMOXARIFE",
                        "CDLOCALDEST" => "P_LOCALIZA",
                        "CDLOCALDEST" => "P_TLOCALIZA",
                        "CDALMOXORIG" => "P_ALMOXORI",
                        "CDALMOXORIG" => "P_TALMOXORI",
                        "CDLOCALORIG" => "P_LOCALIZAORI",
                        "CDLOCALORIG" => "P_TLOCALIZAORI",
                        "NRREQUESTO" => "P_NRREQUESTO",
                        "TNRREQUESTO" => "P_TNRREQUESTO",
                        "DATAINI" => "P_DATAINI",
                        "DATAFIN" => "P_DATAFIN",
                        "NRORG" => "P_NRORG"
                    )
            )
    );

    public function __construct(ReportService $reportService, $dataSourceManager, $environment, $birtStrategy) {
        $this->reportService       = $reportService;
        $this->dataSourceManager   = $dataSourceManager;
        $this->nrorg = $environment->getNrorgTrab();
        $this->birtStrategy        = $birtStrategy;
        
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        
        $reportName = $row['NMRELATORIO'];
        
        $parametersRow = array();
        
        $parametersRow['P_CDFILIAL'] = $row['CDFILIAL'];
        $row['P_CDFILIAL'] = $row['CDFILIAL'];
        if ($row['CDALMOXDEST']!== ''){
            $parametersRow['P_ALMOXARIFE'] = $row['CDALMOXDEST'];
            $row['P_ALMOXARIFE'] = $row['CDALMOXDEST'];
            $parametersRow['P_TALMOXARIFE'] = $row['CDALMOXDEST'];
            $row['P_TALMOXARIFE'] = $row['CDALMOXDEST'];
        }else{
            $parametersRow['P_ALMOXARIFE'] = 'T';
            $row['P_ALMOXARIFE'] = 'T';
            $parametersRow['P_TALMOXARIFE'] = 'T';
            $row['P_TALMOXARIFE'] = 'T';
        }
        if ($row['CDLOCALDEST']!== ''){
            $parametersRow['P_LOCALIZA'] = $row['CDLOCALDEST'];
            $row['P_LOCALIZA'] = $row['CDLOCALDEST'];
            $parametersRow['P_TLOCALIZA'] = $row['CDLOCALDEST'];
            $row['P_TLOCALIZA'] = $row['CDLOCALDEST'];
        }else{
            $parametersRow['P_LOCALIZA'] = 'T';
            $row['P_LOCALIZA'] = 'T';
            $parametersRow['P_TLOCALIZA'] = 'T';
            $row['P_TLOCALIZA'] = 'T';
        }
        if ($row['CDALMOXORIG']!== ''){
            $parametersRow['P_ALMOXORI'] = $row['CDALMOXORIG'];
            $row['P_ALMOXORI'] = $row['CDALMOXORIG'];
            $parametersRow['P_TALMOXORI'] = $row['CDALMOXORIG'];
            $row['P_TALMOXORI'] = $row['CDALMOXORIG'];
        }else{
            $parametersRow['P_ALMOXORI'] = 'T';
            $row['P_ALMOXORI'] = 'T';
            $parametersRow['P_TALMOXORI'] = 'T';
            $row['P_TALMOXORI'] = 'T';
        }
        if ($row['CDLOCALORIG']!== ''){
            $parametersRow['P_LOCALIZAORI'] = $row['CDLOCALORIG'];
            $row['P_LOCALIZAORI'] = $row['CDLOCALORIG'];
            $parametersRow['P_TLOCALIZAORI'] = $row['CDLOCALORIG'];
            $row['P_TLOCALIZAORI'] = $row['CDLOCALORIG'];
        }else{
            $parametersRow['P_LOCALIZAORI'] = 'T';
            $row['P_LOCALIZAORI'] = 'T';
            $parametersRow['P_TLOCALIZAORI'] = 'T';
            $row['P_TLOCALIZAORI'] = 'T';
        }
        $parametersRow['P_NRREQUESTO'] = 'T';
        $row['P_NRREQUESTO'] = 'T';
        $parametersRow['P_TNRREQUESTO'] = 'T';
        $row['P_TNRREQUESTO'] = 'T';
        $parametersRow['P_DATAINI'] = $row['DATAINI'];
        $row['P_DATAINI'] = $row['DATAINI'];
        $parametersRow['P_DATAFIN'] = $row['DATAFIN'];
        $row['P_DATAFIN'] = $row['DATAFIN'];
        $parametersRow['P_NRORG'] = $this->nrorg;
        $row['P_NRORG'] = $this->nrorg;
        $row["NRORG"] = $parametersRow['P_NRORG'];
        $parametersRow['__format'] = $row["__FORMAT"];
        $row['__format'] = $row["__FORMAT"];
        $this->birtStrategy->setReportFormat($row['__FORMAT']);
        
        
        $birtURL = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow);
        $birtLink = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow, true);
        
        $response->addMessage(new DTO\Response\Message($birtURL));
        $response->addMessage(new DTO\Response\Message($birtLink)); 
        
        /*
        $birtLink = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow, true);
        $response->addMessage(new DTO\Response\Message($birtLink));
        
        $birtURL = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow);
        $birtLink = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow, true);
        
        $response->addMessage(new DTO\Response\Message($birtLink)); 
        $response->addMessage(new DTO\Response\Message($birtURL));*/
    }   

}