var est33500_relatorio_customizavel_requisicao_estoque = function(ScreenService, General, templateManager, EstUtil, ZhLayoutPreferences, Est33000_RequisicaoEstoque_Service, ZhFilterPreferences) {

    var dataSourceFilterBkp = {};
    var OnEnterFilter = 0;
    var ParamFilialResponse = {};
    
    var mensagens = {
        reqEncerrada: 'Operação bloqueada. Requisição já encerrada',
        filter: 'Selecione uma filial no filtro antes de adicionar.'
    };
    
    
    //as duas funções a seguir servem para garantir que a aba "produtos" não ficará congelada após o export de um pdf ou xls, está sendo feito um backup do dataSourceFilter 
    this.bkpGridprodutoFilter = function() {
     let widgetGrid = templateManager.container.getWidget('gridProdutosRequisicao');
     dataSourceFilterBkp = Util.clone(widgetGrid.dataSourceFilter); 
    };
    
    this.restauraBkp = function () {
     let widgetGrid = templateManager.container.getWidget('gridProdutosRequisicao');
     widgetGrid.dataSourceFilter = dataSourceFilterBkp;
    };

    this.openFilter = function(widget) {
        this.setFieldsGerais(widget);
        var rowsToSet = {};
        /*this.getFilialLogada().then(function(success) {
           
           
        }.bind(this));*/
        rowsToSet.CDFILIAL = getLocalVar("CDFILIAL");
        rowsToSet.NMFILIAL = getLocalVar("NMFILIAL");

        if (getLocalVar("IDUTILDTPROC") == "S" && getLocalVar("IDUTILDTPROC")) {
            var dataProcessamento = getLocalVar("DTPROCESSA");
            console.log(dataProcessamento);
            rowsToSet.DTREQUESTO = { start: "01" + dataProcessamento.substring(2), end: dataProcessamento };
            rowsToSet.DTPREVREQU = { start: "01" + dataProcessamento.substring(2), end: dataProcessamento };

        }
        else {
            var data = moment().format('DD/MM/YYYY');
            rowsToSet.DTREQUESTO = { start: "01" + data.substring(2), end: data };
            rowsToSet.DTPREVREQU = { start: "01" + data.substring(2), end: data };
        }

        ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(function() {
            let filtro = templateManager.container.getActiveWidget();
            this.onChangeUnidade(filtro, true);
        }.bind(this));
    };

    this.getFilialLogada = function() {
        var filter = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": "FILIAL_LOGADA"
        }];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };

    this.setFieldsGerais = function(widget) {
        templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
    };

    this.onChangeUnidade = function(widget, onEnter) {
        if (OnEnterFilter === 0 || widget.name == 'zhFilterPreferencesSelectConditions') {
            this.apagaValorAlmoxarifadoLocalizacao(widget, 'CDALMOXORIG', 'DSALMOXORIG');
            this.apagaValorAlmoxarifadoLocalizacao(widget, 'CDLOCALORIG', 'DSLOCALORIG');
            this.apagaValorAlmoxarifadoLocalizacao(widget, 'CDALMOXDEST', 'DSALMOXDEST');
            this.apagaValorAlmoxarifadoLocalizacao(widget, 'CDLOCALDEST', 'DSLOCALDEST');
            if (onEnter === true) {
                this.getParamFilial(widget);
            }
            OnEnterFilter++;
        }
    };

    this.apagaValorAlmoxarifadoLocalizacao = function(widget, codigo, nome) {
        widget.currentRow[codigo] = '';
        widget.currentRow[nome] = '';
    };

    this.filialControlaEstoque = function() {
        let activeWidget = templateManager.container.getActiveWidget();

        this.getFilialLogada(activeWidget.currentRow.CDFILIAL).then((success) => {
            let returnedDataset = success.dataset.paramfilial[0];
            if (returnedDataset.IDCTRLESTQ != 'S') {
                activeWidget.currentRow.CDCDFILIAL = null;
                activeWidget.currentRow.NMFILIAL = null;
                ScreenService.showMessage('Filial logada não controla estoque.');
            }
        });
    };

    this.getFilialLogada = function(filial) {

        let filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": filial
                }
		    ];
        return General.callRestEngine('est#/crud/paramfilial', 'FilterData', filter);
    };

    this.getParamFilial = function(widget) {
        var filial = widget.currentRow.CDFILIAL || 'FILIAL_LOGADA';
        Est33000_RequisicaoEstoque_Service.getParamFilial(filial).then(function(succes) {
            if (succes.dataset) {
                if (succes.dataset.paramfilial_paramvalidacoes[0]) {
                    this.setCampos(widget, succes.dataset.paramfilial_paramvalidacoes[0], filial);
                }
                else {
                    ScreenService.showMessage("Não retornaram dados de parametrização para essa filial.");
                }
            }
        }.bind(this), function(error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    this.setCampos = function(widget, array, filial) {
        //Setando datas do campo Data
        var dtprocessa = array.DTPROCESSA;
        var dtinicial = moment(dtprocessa, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
        if (!widget.currentRow.DTREQUESTO) {
            widget.currentRow.DTREQUESTO = {
                end: dtprocessa,
                period: undefined,
                start: dtinicial
            };

        }
        if (!widget.currentRow.DTPREVREQU) {
            widget.currentRow.DTPREVREQU = {
                end: dtprocessa,
                period: undefined,
                start: dtinicial
            };
        }
        if (!widget.currentRow.DTREQUESTO.start) widget.currentRow.DTREQUESTO.start = dtinicial;
        if (!widget.currentRow.DTREQUESTO.period) widget.currentRow.DTREQUESTO.period = undefined;
        if (!widget.currentRow.DTREQUESTO.end) widget.currentRow.DTREQUESTO.end = dtprocessa;
        if (!widget.currentRow.DTPREVREQU.start) widget.currentRow.DTPREVREQU.start = dtinicial;
        if (!widget.currentRow.DTPREVREQU.period) widget.currentRow.DTPREVREQU.period = undefined;
        if (!widget.currentRow.DTPREVREQU.end) widget.currentRow.DTPREVREQU.end = dtprocessa;
        widget.currentRow.IDUTILALMOX = array.IDUTILALMOX;
        widget.currentRow.IDUTILLOTE = array.IDUTILLOTE;
        widget.currentRow.IDUTILLCESTQ = array.IDUTILLCESTQ;

        ParamFilialResponse.IDUTILALMOX = array.IDUTILALMOX;
        ParamFilialResponse.IDUTILLOTE = array.IDUTILLOTE;
        ParamFilialResponse.IDUTILLCESTQ = array.IDUTILLCESTQ;

        if (filial === 'FILIAL_LOGADA') {
            widget.currentRow.CDFILIAL = array.CDFILIAL;
            widget.currentRow.NMFILIAL = array.NMFILIAL;
        }
    };

    //realiza controle para não permirir almoxarifado e localização  de origem igual ao de destino
    this.controlaValoresDestinoOrigem = function(field, tipo, campoAtual, campoDestino) {
        const widget = field.widget;
        let filtro = widget.currentRow;

        if (tipo == 'Almoxarifado') {
            if (field.value()) {
                // se a unidade controla localização, o almoxarifado de origem pode ser igual ao de destino
                if (filtro.IDUTILLCESTQ == 'N') {
                    if (widget.currentRow[campoAtual] == widget.currentRow[campoDestino]) {
                        ScreenService.showMessage('Almoxarifado de origem igual ao Almoxarifado de destino.');
                        field.value('');
                        widget.currentRow[campoAtual] = '';
                    }
                }
            }
        }
        else if ('Localização') {
            if (field.value()) {
                if (widget.currentRow[campoAtual] == widget.currentRow[campoDestino]) {
                    ScreenService.showMessage('Localização de origem igual a Localização de destino.');
                    field.value('');
                    widget.currentRow[campoAtual] = '';
                }
            }
        }
    };

    this.recarregarDataField = function(field) {
        field.reload().then(
            function(Success) {
                if (field.dataSource.data.length == 0) {
                    self.mensagemDataVazio(field.name);
                }
            },
            function(callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
    };

    self.mensagemDataVazio = function(nomeField) {
        switch (nomeField) {
            case 'DSALMOXORIG':
                /* falls through */
            case 'DSALMOXDEST':
                ScreenService.showMessage('Não há almoxarifado cadastrado(a) para a unidade informada.');
                break;
            case 'DSLOCALORIG':
                /* falls through */
            case 'DSLOCALDEST':
                ScreenService.showMessage('Não há localização cadastrado(a) para o almoxarifado informado.');
                break;
        }
    };

    this.preparaParametosQueryRequisicaoEstoque = function(widget) {
        var widgetPrincipal = widget,
            dataSourceFilter = widgetPrincipal.dataSourceFilter,
            currentRowPopup = widgetPrincipal.appliedFilter.FILTER_ROW;
        var filtroSetor = [];
        if (currentRowPopup.CDSETOR) {
            filtroSetor = [{
                    "name": "CDSETOR",
                    "operator": "=",
                    "value": currentRowPopup.CDSETOR
                },
                {
                    "name": "P_TCDSETOR",
                    "operator": "=",
                    "value": ""
                }
            ];
        }
        else {
            filtroSetor = [{
                    "name": "CDSETOR",
                    "operator": "=",
                    "value": ""
                },
                {
                    "name": "P_TCDSETOR",
                    "operator": "=",
                    "value": "T"
                }
            ];
        }

        var filtro = [{
                "name": "CDFILIAL",
                "operator": "=",
                "value": currentRowPopup.CDFILIAL
            },
            {
                "name": "P_DTREQUINI",
                "operator": "=",
                "value": currentRowPopup.DTREQUESTO != null ? currentRowPopup.DTREQUESTO.start : null
            },
            {
                "name": "P_DTREQUFIN",
                "operator": "=",
                "value": currentRowPopup.DTREQUESTO != null ? currentRowPopup.DTREQUESTO.end : null
            },
            {
                "name": "P_DTPREVINI",
                "operator": "=",
                "value": currentRowPopup.DTPREVREQU != null ? currentRowPopup.DTREQUESTO.start : null
            },
            {
                "name": "P_DTPREVFIN",
                "operator": "=",
                "value": currentRowPopup.DTPREVREQU != null ? currentRowPopup.DTREQUESTO.end : null
            },
            {
                "name": "CDALMOXDEST",
                "operator": "=",
                "value": currentRowPopup.CDALMOXDEST || ''
            },
            {
                "name": "CDALMOXORIG",
                "operator": "=",
                "value": currentRowPopup.CDALMOXORIG || ''
            },
            {
                "name": "CDLOCALDEST",
                "operator": "=",
                "value": currentRowPopup.CDLOCALDEST || ''
            },
            {
                "name": "CDLOCALORIG",
                "operator": "=",
                "value": currentRowPopup.CDLOCALORIG || ''
            },
            {
                "name": "IDSTATUSREQ",
                "operator": "=",
                "value": currentRowPopup.IDSTATUSREQ || 'T'
            }
        ];

        filtro.push(filtroSetor[0]);
        filtro.push(filtroSetor[1]);
        widget.dataSourceFilter = filtro;
        widget.reload();
    };

    this.addRequisicaoEstoque = function(widget) {
        //var gridProduto = templateManager.container.getWidget('gridProdutosRequisicao');
        //gridProduto.newRow();
        if (EstUtil.onValidateFilterRequirement(widget, true)) return;
        var Data = new Date();
        var dataDia;
        var dataMonth;
        if (Data.getDate() < 10) dataDia = '0' + Data.getDate();
        else dataDia = Data.getDate();
        if (Data.getMonth() <= 8) dataMonth = '0' + (Data.getMonth() + 1);
        else dataMonth = Data.getMonth() + 1;
        var dataAtual = dataDia + '/' + dataMonth + '/' + Data.getFullYear();
        widget.currentRow.DTREQUESTO = dataAtual;
        widget.currentRow.DTPREVREQU = dataAtual;
        widget.widgets[0].getField('NRLOTEESTQ').readOnly = true;
     //   this.controlaUtilizacaoAlmoxarifadoLocalizacao(widget, widget.appliedFilter.FILTER_ROW.IDUTILALMOX, widget.appliedFilter.FILTER_ROW.IDUTILLCESTQ);
        this.controlaStatusWidgets(widget, widget.name, false);
        this.validaDatas('DTREQUESTO', 'DTPREVREQU', 'LIMPAR');
        this.valoresMinMaxData(widget, 'DTREQUESTO', 'DTPREVREQU', 'LIMPAR');
        this.fixDataSourceFilter(widget);
        widget.currentRow.NMOPERINCLUSAO = getLocalVar('NMOPERADOR');
    };

    this.cancelarRequisicaoEstoque = function(args) {
        var gridProdutos = templateManager.container.getWidget('gridProdutosRequisicao');
        this.controlaStatusWidgets(args.owner.widget, 'gridRequisicaoEstoque', true);
        General.backOrCancel(args);
        if (gridProdutos.mode == 'edit') {
            gridProdutos.list();
            gridProdutos.getField('NRLOTEESTQ').readOnly = false;
            var gridMensagemProduto = templateManager.container.getWidget('gridMensagemPorduto');
            gridMensagemProduto.enabled = true;
        }
    };

    this.cancelarProdutosRequisicao = function(args) {
        var widget = args.owner.widget;
        var gridRequisicao = templateManager.container.getWidget('gridRequisicaoEstoque');
        General.backOrCancel(args);
        this.controlaStatusWidgets(widget, 'gridProdutosRequisicao', true);
        if (gridRequisicao.mode == 'edit') {
            gridRequisicao.list(true);
            gridRequisicao.reload();
            gridRequisicao.currentRow = {};

            widget.list(true);
            widget.reload();
            widget.currentRow = {};
            ScreenService.closeSwipe(0);

        }
    };

    this.recarrecarWidgetsFilhas = function(widget) {
        widget.widgets.forEach(function(widg) {
            widg.reload();
        });
    };

    this.controlaStatusWidgets = function(mainWidget, nomeWidgetAtual, status) {
        mainWidget.widgets.forEach(function(widg) {
            if (nomeWidgetAtual !== widg.name)
                widg.enabled = status;
        });

        if (mainWidget.name !== nomeWidgetAtual)
            mainWidget.enabled = status;
    };

    this.salvarRequisicaoEstoque = function(widget) {
        //caso esteja cadastrando a requisição , faz o procedimento para adicionar um produto , pois não se pode cadastrar a requsição sem produtos.
        var gridProdutos = templateManager.container.getWidget('gridProdutosRequisicao');
        if (widget.currentRow.__is_new) {
            if (widget.isValid()) {
                widget.currentRow.CDFILIAL = widget.appliedFilter.FILTER_ROW.CDFILIAL;
                gridProdutos.enabled = true;
                gridProdutos.activate().then(function() {
                    //gridProdutos.newRow();
                    var gridMensagemProduto = templateManager.container.getWidget('gridMensagemPorduto');
                    gridMensagemProduto.enabled = false;
                });
                ScreenService.showMessage('É necessário cadastrar ao menos um produto para salvar a requisição.');
            }
        }
        else {
            //caso esteja apenas editando algum dado da requisição
            General.saveCrud(widget).then(
                function(Sucess) {
                    this.controlaStatusWidgets(widget, widget.name, true);
                    gridProdutos.getField('NRLOTEESTQ').readOnly = false;
                }.bind(this),
                function(callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }
            );
        }
    };

    this.salvarProdutosRequisicao = function(widget) {
        var gridRequisicao = templateManager.container.getWidget('gridRequisicaoEstoque');
        var gridMensagemProduto = templateManager.container.getWidget('gridMensagemPorduto');
        if (widget.currentRow.__is_new) {
            widget.currentRow.CDFILIAL = gridRequisicao.currentRow.CDFILIAL;
            widget.currentRow.NRREQUESTO = gridRequisicao.currentRow.NRREQUESTO;
        }

        if (gridRequisicao.mode == 'edit') {
            //caso esteja adicionado a requisição e o produto
            if (widget.isValid()) {
                widget.currentRow.NRSEQITEM = '';
                var rows = {
                    "requisicao": gridRequisicao.currentRow,
                    "produtos": widget.currentRow
                };
                ScreenService.showLoader();
                Est33000_RequisicaoEstoque_Service.salvarRequisicaoProdutos(rows).then(
                    function(Success) {
                        gridRequisicao.view();
                        gridRequisicao.currentRow.IDSTATUSREQ = Success.dataset.requesto.idstatusreq;
                        gridRequisicao.currentRow.IDREQUESTO = Success.dataset.requesto.idrequesto;
                        gridRequisicao.currentRow.NRREQUESTO = Success.dataset.requesto.nrrequesto;
                        gridRequisicao.currentRow.NRORG = Success.dataset.requesto.nrorg;
                        gridRequisicao.currentRow.__is_new = false;
                        gridMensagemProduto.enabled = true;
                        ScreenService.goBack();
                        widget.activate();
                        widget.list();
                        widget.reload();
                        widget.getField('NRLOTEESTQ').readOnly = false;
                        ScreenService.hideLoader();
                    }.bind(this),
                    function(callback) {
                        if (callback.data) {
                            ScreenService.showMessage(callback.data.error);
                        }
                        ScreenService.hideLoader();
                    }
                );
            }
        }
        else {
            if (widget.currentRow.__is_new == true) {
                //caso esteja adicionado apenas o produto
                if (widget.isValid()) {
                    widget.currentRow.NRSEQITEM = '';
                    ScreenService.showLoader();
                    Est33000_RequisicaoEstoque_Service.salvarnovoProduto(widget.currentRow).then(
                        function(Success) {
                            gridRequisicao.currentRow.IDSTATUSREQ = Success.dataset.requesto.idstatusreq;
                            gridRequisicao.currentRow.IDREQUESTO = Success.dataset.requesto.idrequesto;
                            gridMensagemProduto.enabled = true;
                            ScreenService.goBack();
                            widget.activate();
                            widget.list();
                            widget.reload();
                            ScreenService.hideLoader();
                        }.bind(this),
                        function(callback) {
                            if (callback.data) {
                                ScreenService.showMessage(callback.data.error);
                            }
                            ScreenService.hideLoader();
                        }
                    );
                }
            }
            else {
                //caso esteja atualizando o produto
                ScreenService.showLoader();
                General.saveCrud(widget).then(
                    function(Sucess) {
                        this.controlaStatusWidgets(widget, widget.name, true);
                        ScreenService.hideLoader();
                    }.bind(this),
                    function(callback) {
                        if (callback.data) {
                            ScreenService.showMessage(callback.data.error);
                        }
                        ScreenService.hideLoader();
                    }
                );
            }
        }
    };

    this.deletarProdutoRequisicao = function(widget) {
        if (widget.getParent().currentRow.IDSTATUSREQ === 'E') return ScreenService.showMessage(mensagens.reqEncerrada);
        var gridRequisicao = templateManager.container.getWidget('gridRequisicaoEstoque');
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function(success) {
            Est33000_RequisicaoEstoque_Service.deletarProduto(widget.currentRow).then(
                function(Success) {
                    gridRequisicao.currentRow.IDSTATUSREQ = Success.dataset.requesto.idstatusreq;
                    gridRequisicao.currentRow.IDREQUESTO = Success.dataset.requesto.idrequesto;
                    ScreenService.goBack();
                    widget.activate();
                    widget.reload();
                }.bind(this),
                function(callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }
            );
        });
    };

    this.addProductRequisition = function(widget) {
        if (widget.getParent().currentRow.IDSTATUSREQ === 'E') return ScreenService.showMessage(mensagens.reqEncerrada);
        this.controlaStatusWidgets(widget, 'gridProdutosRequisicao', false);
        widget.newRow();
        widget.currentRow.IDSTITREQU = 'A';
    };

    this.editProductRequisition = function(widget) {
        if (widget.getParent().currentRow.IDSTATUSREQ === 'E') return ScreenService.showMessage(mensagens.reqEncerrada);
        this.controlaStatusWidgets(widget, 'gridProdutosRequisicao', false);
        General.edit(widget);

    };

    this.editarRequisicao = function(widget) {
        if (widget.currentRow.IDSTATUSREQ === 'E') ScreenService.showMessage(mensagens.reqEncerrada);
        else {
            General.edit(widget);
            Est33000_RequisicaoEstoque_Service.getParamFilial(widget.currentRow.CDFILIAL).then((succes) => {
                var paramfilial = succes.dataset.paramfilial_paramvalidacoes[0];
                if (paramfilial.IDUTILALMOX == 'S') {

                    widget.getField('DSALMOXORIG').readOnly = false;
                    widget.getField('DSALMOXDEST').readOnly = false;

                    if (paramfilial.IDUTILLCESTQ == 'S') {
                        widget.getField('DSLOCALORIG').readOnly = false;
                        widget.getField('DSLOCALDEST').readOnly = false;
                    }
                }
                this.controlaStatusWidgets(widget, 'gridRequisicaoEstoque', false);
                this.valoresMinMaxData(widget, 'DTREQUESTO', 'DTPREVREQU', 'SETAR');
            });
        }
    };

    this.deletarRequisicao = function(widget) {
        var gridRequisicao = templateManager.container.getWidget('gridRequisicaoEstoque');
        if (gridRequisicao.currentRow.IDSTATUSREQ === 'E') ScreenService.showMessage(mensagens.reqEncerrada);
        else {
            ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function(success) {
                Est33000_RequisicaoEstoque_Service.deletarRequisicao(widget.currentRow).then(
                    function(Success) {
                        ScreenService.goBack();
                        widget.activate();
                        widget.reload();
                    }.bind(this),
                    function(callback) {
                        if (callback.data) {
                            ScreenService.showMessage(callback.data.error);
                        }
                    }
                );
            });
        }
    };

    this.salvarMensagemProduto = function(widget) {
        widget.saveRow().then(
            function(Sucess) {
                this.controlaStatusWidgets(templateManager.container.getWidget('gridProdutosRequisicao'), widget.name, true);
                var currentRow = widget.currentRow;
                currentRow.__is_new = false;
                widget.template = widget.templateToView;
                widget.view();
                widget.reload();
            }.bind(this),
            function(callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
    };

    this.editMessage = function(widget) {
        if (widget.getParent().getParent().currentRow.IDSTATUSREQ === 'E') return ScreenService.showMessage(mensagens.reqEncerrada);
        General.widgetEdit(widget);
    };

    this.widgetOnEnter = function(args) {
        var widget = args.owner;
        if (widget.dataSource.data[0]) {
            widget.currentRow = widget.dataSource.data[0];
        }
        else {
            widget.currentRow = {
                "__is_new": true,
                "CDFILIAL": widget.getParent().currentRow.CDFILIAL,
                "NRREQUESTO": widget.getParent().currentRow.NRREQUESTO,
                "CDPRODUTO": widget.getParent().currentRow.CDPRODUTO,
                "NRSEQITEM": widget.getParent().currentRow.NRSEQITEM
            };
        }
    };

    this.validaDatas = function(field, nomeFieldOutraData, verificadorMinMax) {
        var widget = field.widget;
        if (verificadorMinMax == 'MIN') {
            widget.getField(nomeFieldOutraData).minDate = widget.currentRow[field.name];
        }
        else if (verificadorMinMax == 'MAX') {
            widget.getField(nomeFieldOutraData).maxDate = widget.currentRow[field.name];
        }
    };

    this.valoresMinMaxData = function(widget, nomeDataMIN, nomeDataMAX, verificadorLimpaSetta) {
        if (verificadorLimpaSetta == 'LIMPAR') {
            widget.getField(nomeDataMIN).maxDate = null;
            widget.getField(nomeDataMAX).minDate = null;
        }
        else if (verificadorLimpaSetta == 'SETAR') {
            widget.getField(nomeDataMIN).maxDate = widget.currentRow[nomeDataMAX];
            widget.getField(nomeDataMAX).minDate = widget.currentRow[nomeDataMIN];
        }
    };

    this.verficaProdutoControlaEstoque = function(widget) {
        if (widget.currentRow.CDARVPROD) {
            if (widget.currentRow.IDPRODATIV == 'A') {
                if (widget.currentRow.IDUTCTRLLOTE && templateManager.container.getWidget('gridRequisicaoEstoque').appliedFilter.FILTER_ROW.IDUTILLOTE) {
                    widget.currentRow.NRLOTEESTQ = '';
                    widget.getField('NRLOTEESTQ').readOnly = false;
                }
                if (widget.currentRow.IDCNTRESTOQ == 'N') {
                    widget.currentRow.CDARVPROD = null;
                    widget.currentRow.NMPRODUTO = null;
                    widget.currentRow.SGUNIDADE = null;
                    ScreenService.showMessage('Produto não controla estoque.');
                }
            }
            else {
                widget.currentRow.CDARVPROD = null;
                widget.currentRow.NMPRODUTO = null;
                widget.currentRow.SGUNIDADE = null;
                ScreenService.showMessage('O produto encontra-se inativo para a filial.');
            }
        }
    };

    this.controlaLoteProduto = function(field) {
        var widget = field.widget;
        field.reload().then(
            function(Success) {
                if (ParamFilialResponse.IDUTILLOTE == 'S') {
                    if (widget.currentRow.CDARVPROD) {
                        if (widget.currentRow.IDUTCTRLLOTE == 'S') {
                            if (field.dataSource.data.length == 0) {
                                ScreenService.showMessage('Lote não cadastrado para o produto informado.');
                                field.dataSource.data = null;
                            }
                        }
                        else {
                            ScreenService.showMessage('Produto não controla lote.');
                            field.dataSource.data = null;
                        }
                    }
                    else {
                        ScreenService.showMessage('Lote não cadastrado para o produto informado.');
                        field.dataSource.data = null;
                    }
                }
            },
            function(callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
    };

    this.apagaValoresLote = function(widget) {
        widget.currentRow.NRLOTEESTQ = null;
        widget.currentRow.NRSUBLOTE = null;
    };

    this.fixDataSourceFilter = function(widget) {
        if (widget.currentRow.CDFILIAL || widget.appliedFilter.FILTER_ROW.CDFILIAL) {
            var filial = widget.currentRow.CDFILIAL || widget.appliedFilter.FILTER_ROW.CDFILIAL;

            widget.getField('DSALMOXORIG').dataSourceFilter.forEach(function(fil) {
                if (fil.name == 'CDFILIAL') {
                    fil.value = filial;
                }
            });

            widget.getField('DSALMOXDEST').dataSourceFilter.forEach(function(fil) {
                if (fil.name == 'CDFILIAL') {
                    fil.value = filial;
                }
            });

            widget.getField('DSLOCALORIG').dataSourceFilter.forEach(function(fil) {
                if (fil.name == 'CDFILIAL') {
                    fil.value = filial;
                }
            });

            widget.getField('DSLOCALDEST').dataSourceFilter.forEach(function(fil) {
                if (fil.name == 'CDFILIAL') {
                    fil.value = filial;
                }
            });

            templateManager.container.getWidget('gridProdutosRequisicao').getField('NMPRODUTO').dataSourceFilter.forEach(function(fil) {
                if (fil.name == 'CDFILIAL') {
                    fil.value = filial;
                }
            });

            widget.getField('DSALMOXORIG').reload();
            widget.getField('DSALMOXDEST').reload();
            widget.getField('DSLOCALORIG').reload();
            widget.getField('DSLOCALDEST').reload();
            templateManager.container.getWidget('gridProdutosRequisicao').getField('NMPRODUTO').reload();

        }

    };

    this.reportProcess = function(args, afterOpenReport = false) {
        const widget = args.owner;
        const { CDFILIAL, NRREQUESTO, DSREQUESTO, DTREQUESTO } = widget.getParent().currentRow;

        if (afterOpenReport) {
            ZhLayoutPreferences.applyOriginalLayout(widget);
        }
        else {

            let filter = [
                {
                    "label": "Filial",
                    "value": CDFILIAL
                },
                {
                    "label": "Requisição",
                    "value": NRREQUESTO
                },
                {
                    "label": "Data Requisição",
                    "value": DTREQUESTO.substring(0, 10)
                },
                {
                    "label": "Descrição",
                    "value": DSREQUESTO
                }
            ];

            args.e.metadata.filter = filter;
            args.e.metadata.title = "Emissão Requisição de Estoque";

            ZhLayoutPreferences.applyOriginalLayout(widget);
        }
    };
    
    this.generateReport = function(widget, format) {
        var widgetPrincipal = widget,
            dataSourceFilter = widgetPrincipal.dataSourceFilter,
            row = widgetPrincipal.appliedFilter.FILTER_ROW;
            row.__FORMAT = format;
            row.NMRELATORIO = 'EST33401';
            row.__report_name = 'EST33401';
            row.REPORT_NAME = 'EST33401';
            row.NRREQUESTO = 'T';
            row.TNRREQUESTO = 'T';
            row.DATAINI = row.DTREQUESTO.start;
            row.DATAFIN = row.DTREQUESTO.end;
            row.CDSETOR = row.CDSETOR?row.CDSETOR:'T';
            row.CDALMOXDEST = row.CDALMOXDEST?row.CDALMOXDEST:'T';
            row.CDALMOXORIG = row.CDALMOXORIG?row.CDALMOXORIG:'T';
            row.CDLOCALDEST = row.CDLOCALDEST?row.CDLOCALDEST:'T';
            row.CDLOCALORIG = row.CDLOCALORIG?row.CDLOCALORIG:'T';
            row.DSALMOXDEST = row.DSALMOXDEST?row.DSALMOXDEST:'T';
            row.DSALMOXORIG = row.DSALMOXORIG?row.DSALMOXORIG:'T';
            row.DSLOCALDEST = row.DSLOCALDEST?row.DSLOCALDEST:'T';
            row.DSLOCALORIG = row.DSLOCALORIG?row.DSLOCALORIG:'T';
            
        General.openReport("est_relatorios#/requisicao_de_estoque", row.__report_name, row);
		
	};

};
Configuration(function(ContextRegister) {
    ContextRegister.register('est33500_relatorio_customizavel_requisicao_estoque', est33500_relatorio_customizavel_requisicao_estoque);
});
