function FooterController($scope, templateManager, ScreenService, $rootScope, metaDataFactory) {
	var self = this;

	$scope.$on("openFilter", function(event, widget) {
		$scope.widget = widget;
		templateManager.updateTemplate();
	});

	this.shouldShowNeverActionsAsGrouped = function(){
		return templateManager.container.getActiveWidget().showNeverActionsAsGrouped;
	};

	this.isPopupNoBlock = function() {
		return $rootScope.isPopupOpen() && !!$rootScope._currentPopup && !!$rootScope._currentPopup.popupNoBlock;
	};

	this.__defineGetter__('sourceActions', function() {
		return $rootScope.isPopupOpen() && $rootScope._currentPopup ? $rootScope._currentPopup : templateManager.container;
	});

	var actionsWidget = metaDataFactory.widgetFactory({
		"id": 9999,
		"name": "actions_widget",
		"label": ScreenService.i18n("Actions"),
		"popupNoBlock": false,
		"isVisible": true,
		"container": templateManager.container,
		"template": "widget/actions-popup.html",
		"fields": [],
		"actions": [{
			"label": ScreenService.i18n("Cancel"),
			"showAsAction": "back",
			"isVisible": true,
			"showOnForm": true,
			"showOnList": true,
			"events": [{
				"name": "ActionEvent",
				"code": "ScreenService.closePopup();args.owner.widget.sourceWidget.activate()",
				"id": 9998
			}]
		}]
	});

	$scope.openActionsPopup = function() {
		actionsWidget.sourceWidget = templateManager.container.getActiveWidget();
		if (templateManager.container.getActionsByVisibility('never').length > 0) {
			ScreenService.openPopup(actionsWidget);
		}
	};

	$scope.$watch(function() { return self.sourceActions; }, function(newValue, oldValue) {
		$rootScope.$broadcast('changeSourceActions', newValue);
	});
}
