package com.javaseleniumtemplate.tests;


import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.dbsteps.DBSteps;
import com.javaseleniumtemplate.flows.EntradaDeEstoqueFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.EntradaDeEstoquePage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.Assert;
import org.testng.annotations.Ignore;
import org.testng.annotations.Test;

public class EntradaDeEstoqueTests extends TestBase {
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    EntradaDeEstoqueFlows entradaDeEstoqueFlows;
    EntradaDeEstoquePage entradaDeEstoquePage;


    @Test(priority = 1,description = "Est-03")
    public void EfetuarEntradaDeEstoque() {

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        entradaDeEstoqueFlows = new EntradaDeEstoqueFlows();
        entradaDeEstoquePage = new EntradaDeEstoquePage();

        //Parameteres_login:

        //Parameteres_Lançamento:
        String quantidade = "3";
        String cmpDesc = "Teste Automatizado";
        String descProduto = "SUMO DE LIMAO - CX12 500ML";
        String descAlmoxarifado = "HELA MATRIZ";
        String DescCampoLote = "025/50";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String valorUnitario = "1,2";
        String valorEstoqueEsperado = "18";
        String valorTotalEstoqueEsperado = "18";
        String valorUnitarioLancado = "1.2";


        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoEntradaDeEstoque();
        entradaDeEstoqueFlows.aplicarFiltro(descUnidade, descAlmoxarifado);
        entradaDeEstoqueFlows.AdicionarEntradaEstoque(cmpDesc, descProduto, quantidade, descAlmoxarifado, DescCampoLote, valorUnitario);

        //Banco

        String numeroLancamento = entradaDeEstoquePage.retornaNumeroLacamento();
       Assert.assertTrue(DBSteps.retornaQuatidadeEstoque(numeroLancamento).contains(valorEstoqueEsperado));
        String valorLancamentoTotalEstoque = entradaDeEstoquePage.retornaNumeroLacamento();
       Assert.assertTrue(DBSteps.retornaValorTotalQuantidadeEstoque(valorLancamentoTotalEstoque).contains(valorTotalEstoqueEsperado));
        Assert.assertEquals(numeroLancamento, valorLancamentoTotalEstoque, "comparação entre o valor lançado e o valor que tem em estoque");
        Assert.assertTrue(DBSteps.retornaValorUnitarioLancadoEstoque(numeroLancamento).contains(valorUnitarioLancado));//verifica o valor lançado no banco do valor unitario


    }

    @Test (priority = 2,description = "Est-25")
    public void EditarEntradaEstoque() {
        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        entradaDeEstoqueFlows = new EntradaDeEstoqueFlows();
        entradaDeEstoquePage = new EntradaDeEstoquePage();



        //Parameteres_Editar

        String cmpDesc2 = "Deletar";
        String cmpProduto = "Hela Poultry Broth Paste Clear KG";
        String DescCampoLote = "025/50";
        String valorUnitario = "1,5";
        String quantidade = "2";

        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoEntradaDeEstoque();
        //entradaDeEstoqueFlows.aplicarFiltro(descUnidade,descAlmoxarifado);
        entradaDeEstoqueFlows.EditarEntradaEstoque(cmpDesc2, cmpProduto, DescCampoLote,quantidade, valorUnitario);

    }

    @Test(priority = 3,description = "Est-26")
    public void ExcluirEntradaDeEstoque() {
        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        entradaDeEstoqueFlows = new EntradaDeEstoqueFlows();
        entradaDeEstoquePage = new EntradaDeEstoquePage();


        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoEntradaDeEstoque();

        entradaDeEstoqueFlows.ExcluirEntradaDeEstoque();
    }


    @Test(description = "Est-00")
    @Ignore
    public void TesteBanco() {

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        entradaDeEstoqueFlows = new EntradaDeEstoqueFlows();
        entradaDeEstoquePage = new EntradaDeEstoquePage();


        //Rotinas:

        loginFlows.efetuarLogin();
        String ntlancestq = "0000005594";
        String teste = DBSteps.retornaValorUnitarioLancadoEstoque(ntlancestq);

        System.out.println(teste);

    }


}




